import os
import os.path
import sys

def getDirList(root_dir):
	p = str(root_dir)
	if p == "":
		return []
	if p[-1] != "/":
		p += "/"
	a = os.listdir(p)
	b = [os.path.join(root_dir,x) for x in a if os.path.isdir(p+x)]
	return b

def extract_model_property(K, Lag, fold, alpha, beta, modelFile, out_path):
	cmd = "./mf %d %d %s %.6f %.6f %s %s"%(K, Lag, fold, alpha, beta, modelFile, out_path)
	os.system(cmd)

def extract_evl_perf(root_dir, out_path):
	dirlist = getDirList(root_dir)
	file_out = open(out_path, "w")
	beta = 0.01
	for dir in dirlist:
		if dir.find("K") == -1:
			continue

		terms	= dir.replace("/", " ")
		parent	= dir.split()
		parent	= parent[-1]
		terms	= parent.replace("-", " ")
		terms	= terms.split()
		F		= terms[-1]
		SampleLag = terms[-3]
		SampleLag = int(SampleLag[1:])

		filename = "evl-performance.txt"
		filename = os.path.join(dir, filename)
		if os.path.isfile(filename) == False:
			continue

		file_obj = open(filename, "r")
		lines	= file_obj.readlines()
		file_obj.close()

		terms	= lines[2].split()
		K		= int(terms[-1])
		terms = lines[4].split()
		alpha = float(terms[-1])
		terms	= lines[-4].split()
		dAcc	= float(terms[-1])
		terms = lines[-2].split()
		PWL	= float(terms[-1])
		terms = lines[-1].split()
		tAvgEnt = float(terms[-1])

		filename = os.path.join(dir, "model-final.txt")
		extract_model_property(K, SampleLag, F, alpha, beta, filename, "perf.txt")

		rst	= "(K: %d; SampleLag: %d; Kalpha: %.2f; %s): TestAcc: %.6f; TestAvgEntropy: %.6f; PerWordLhood: %.6f\n"%(K, SampleLag, alpha, F, dAcc, tAvgEnt, PWL)
		file_out.write(rst);
	file_out.close()

if __name__ == "__main__":
	root_dir = sys.argv[1]
	out_path = sys.argv[2]
	extract_evl_perf(root_dir, out_path)
