#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

using namespace std;

#define MAX_V	100000
#define MAX_BUF_SIZE 100000
#define NUMERICAL_ZERO 1e-10

int **nw 	= NULL;
int *nwsum 	= NULL;
double alpha, beta;
int K;

void calPhi(FILE *file, double *topicPrEntropy);

int main(int argc, char** argv){
	if (argc == 1) {
		printf("./main [k] [Lag] [fold] [alpha] [beta] [modelFile] [outFile]\n");
		return 1;
	}

	K = atoi(argv[1]);
	int Lag = atoi(argv[2]);
	char* fold = argv[3];
	alpha = atof(argv[4]);
	double Kalpha = alpha;
	beta	= atof(argv[5]);
	char *filename = argv[6];
	char *outfile = argv[7];
	printf("(K: %d; SampleLag: %d; %s; Kalpha: %lf; beta: %lf; inFile: %s; outFile: %s)\n", K, Lag, fold, Kalpha, beta, filename, outfile);

	double topicPrEntropy = 0;
	FILE *file = fopen(filename, "r");
	if (!file) return 1;

	char *oneline = new char[MAX_BUF_SIZE];
	fgets(oneline, MAX_BUF_SIZE, file);
	fgets(oneline, MAX_BUF_SIZE, file);
	if (strlen(oneline) < 100) 
		fgets(oneline, MAX_BUF_SIZE, file);
	delete[] oneline;
	calPhi(file, &topicPrEntropy);
	fclose(file);
	FILE *fout = fopen(outfile, "a");
	fprintf(fout, "(K: %d; SampleLag: %d; Kalpha: %.2f; %s): TopicPrEntropy: %.6f\n", K, Lag, Kalpha, fold, topicPrEntropy);
	fclose(fout);

	return 0;
}

void calPhi(FILE *file, double *topicPrEntropy) {
	int d, k, t, n;
	nw = new int*[K];
	for(k = 0; k < K; ++k){
		nw[k] = new int[MAX_V];
		memset(nw[k], 0, sizeof(int) * MAX_V);
	}
	nwsum = new int[K];
	memset(nwsum, 0, sizeof(int)*K);
	int *nd	= new int[K];

	int N;
	int dLen, label;
	int topic, term;
	fscanf(file, "%d\n", &N);
	int exV = 0;
	for(d = 0; d < N; ++d){
		memset(nd, 0, sizeof(int) * K);
		fscanf(file, "%d %d", &dLen, &label);
		for(n = 0; n < dLen; ++n){
			fscanf(file, "%d:%d", &term, &topic);
			nw[topic][term] 	+= 1;
			nwsum[topic]		+= 1;
			nd[topic]			+= 1;
			if (term >= exV) exV = term + 1;
		}
	}

	double dEnt, val;
	double entropy = 0;
	const double DV = (double)exV * 0.01;
	for(k = 0; k < K; ++k){
		dEnt = 0;
		for(t = 0; t < exV; ++t){
			val = (double)(nw[k][t]+0.01)/ (nwsum[k]+DV);
			dEnt -= val * log(val);
		}
		entropy += dEnt;
	}
	*topicPrEntropy = entropy / (double)K;

	delete[] nd;
	for(int k = 0; k < K; ++k) delete[] nw[k];
	delete[] nw;
	delete[] nwsum;
}
